/*
 * File:   melody_pic16f1827.c
 * Author: kikusan
 *
 * Created on 2012/12/13, 14:15
 */

/*
 * $BEE;R%*%k%4!<%k(B
 * $B%9%$%C%A$r2!$9$H0[$J$k%a%m%G%#$,N.$l$^$9!#(B
 * SW1 $B!V>.$5$J@$3&!W(B
 * SW2 $B!V9S>k$N7n!W(B
 * SW3 $B!V[07nLk!W(B
 * SW4 $B!V>.$5$J@$3&!W"*!V9S>k$N7n!W"*!V[07nLk!W"*!V>.$5$J@$3&!W"*!&!&!&(B
 */

// PIC16F1827 Configuration Bit Settings
#pragma config FOSC = INTOSC, WDTE = OFF, PWRTE = ON,MCLRE = OFF, CP = OFF
#pragma config CPD = OFF, BOREN = ON, CLKOUTEN = OFF, IESO = ON,FCMEN = ON
#pragma config WRT = OFF,PLLEN = ON, STVREN = ON, BORV = LO, LVP = OFF

/******************************************************************************
 $B%$%s%/%k!<%I%U%!%$%k(B
******************************************************************************/
#include <xc.h>

/******************************************************************************
 $BDj?t$NDj5A!JD>@\;XDj!K(B
******************************************************************************/
#define OK      0   //$BLa$jCM(B
#define NG      -1  //$BLa$jCM(B
#define TRUE    0   //$BLa$jCM(B
#define FALSE   -1  //$BLa$jCM(B

//$B%=%U%H%&%'%"%?%$%^(B ----------------------------------------------------------
#define T0      500     //T0(500ms)
#define T1      100     //T1(100ms)
#define T2      0       //T2(0ms)
#define T3      0       //T3(0ms)

//$B%a%m%G%#(B --------------------------------------------------------------
#define KIJUN_ON    0x2d    //$B4p=`2;$,2;3,%F!<%V%k$NG[Ns$N2?HVL\$NMWAG$K$J$k$+(B

/******************************************************************************
 $BDj?t%(%j%"$NDj5A(B(ROM)
******************************************************************************/
//$B%9%-%c%s%G!<%?(B
const unsigned char ScanData[8] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

/******************************************************************************
 $B2;3,%F!<%V%k(B($BJ?6QN'(B)
 {(CCP4$B$K%;%C%H$9$k%3%s%Z%"CM(B),($BA42;Id$ND9$5(B=$B3d9~2s?t(B)}
******************************************************************************/
const unsigned int OnkaiTbl[][2] = {
    {30579, 524},   //C  ,$B%I(B   ,130.81Hz
    {28862, 556},   //C# ,$B%I(B#  ,138.59Hz
    {27242, 588},   //D  ,$B%l(B   ,146.83Hz
    {25714, 624},   //D# ,$B%l(B#  ,155.56Hz
    {24270, 660},   //E  ,$B%_(B   ,164.81Hz
    {22649, 708},   //F  ,$B%U%!(B ,176.61Hz
    {21622, 740},   //F# ,$B%U%!(B#,185.00Hz
    {20408, 786},   //G  ,$B%=(B   ,196.00Hz
    {19263, 832},   //G# ,$B%=(B#  ,207.65Hz
    {18182, 880},   //A  ,$B%i(B   ,220.00Hz
    {17161, 934},   //A# ,$B%i(B#  ,233.08Hz
    {16198, 988},   //B  ,$B%7(B   ,246.94Hz

    {15289,1048},   //C  ,$B%I(B   ,261.63Hz
    {14431,1110},   //C# ,$B%I(B#  ,277.18Hz
    {13621,1176},   //D  ,$B%l(B   ,293.66Hz
    {12856,1246},   //D# ,$B%l(B#  ,311.13Hz
    {12135,1320},   //E  ,$B%_(B   ,329.63Hz
    {11454,1398},   //F  ,$B%U%!(B ,349.23Hz
    {10811,1480},   //F# ,$B%U%!(B#,369.99Hz
    {10204,1570},   //G  ,$B%=(B   ,392.00Hz
    { 9632,1662},   //G# ,$B%=(B#  ,415.30Hz
    { 9091,1760},   //A  ,$B%i(B   ,440.00Hz
    { 8581,1866},   //A# ,$B%i(B#  ,466.16Hz
    { 8099,1976},   //B  ,$B%7(B   ,493.88Hz

    { 7645,2094},   //C  ,$B%I(B   ,523.25Hz
    { 7215,2218},   //C# ,$B%I(B#  ,554.37Hz
    { 6810,2350},   //D  ,$B%l(B   ,587.33Hz
    { 6428,2490},   //D# ,$B%l(B#  ,622.25Hz
    { 6067,2638},   //E  ,$B%_(B   ,659.26Hz
    { 5727,2794},   //F  ,$B%U%!(B ,698.46Hz
    { 5405,2962},   //F# ,$B%U%!(B#,739.99Hz
    { 5102,3138},   //G  ,$B%=(B   ,783.99Hz
    { 4816,3324},   //G# ,$B%=(B#  ,830.61Hz
    { 4545,3522},   //A  ,$B%i(B   ,880.00Hz
    { 4290,3730},   //A# ,$B%i(B#  ,932.33Hz
    { 4050,3952},   //B  ,$B%7(B   ,987.77Hz

    { 3822,4188},   //C  ,$B%I(B   ,1046.50Hz
    { 3608,4436},   //C# ,$B%I(B#  ,1108.73Hz
    { 3405,4700},   //D  ,$B%l(B   ,1174.66Hz
    { 3214,4980},   //D# ,$B%l(B#  ,1244.51Hz
    { 3034,5274},   //E  ,$B%_(B   ,1318.51Hz
    { 2863,5590},   //F  ,$B%U%!(B ,1396.91Hz
    { 2703,5920},   //F# ,$B%U%!(B#,1479.98Hz
    { 2551,6274},   //G  ,$B%=(B   ,1567.98Hz
    { 2408,6646},   //G# ,$B%=(B#  ,1661.22Hz
    { 2273,7040},   //A  ,$B%i(B   ,1760.00Hz    //$B"+4p=`2;"+"+"+"+"+"+"+"+"+"+(B
    { 2145,7460},   //A# ,$B%i(B#  ,1854.66Hz
    { 2025,7902},   //B  ,$B%7(B   ,1973.53Hz

    { 1911,8374},   //C  ,$B%I(B   ,2093.00Hz
    { 1804,8870},   //C# ,$B%I(B#  ,2217.46Hz
    { 1703,9396},   //D  ,$B%l(B   ,2349.32Hz
    { 1607,9958},   //D# ,$B%l(B#  ,2489.02Hz
    { 1517,10548},  //E  ,$B%_(B   ,2637.02Hz
    { 1432,11174},  //F  ,$B%U%!(B ,2793.83Hz
    { 1351,11844},  //F# ,$B%U%!(B#,2959.96Hz
    { 1276,12540},  //G  ,$B%=(B   ,3135.96Hz
    { 1204,13290},  //G# ,$B%=(B#  ,3322.44Hz
    { 1136,14086},  //A  ,$B%i(B   ,3520.00Hz
    { 1073,14912},  //A# ,$B%i(B#  ,3729.31Hz
    { 1012,15812}   //B  ,$B%7(B   ,3951.07Hz
};

/******************************************************************************
 $B3ZIh%F!<%V%k(B
    $B>e0L(B8$B%S%C%H(B(bit15-8)$B!'2;$ND9$5(B
            bit14-8 00h-$BA42;Id(B,01h-2$BJ,2;Id(B,02h-4$BJ,2;Id(B
                    03h-8$BJ,2;Id(B,04h-16$BJ,2;Id(B
            bit15   0-$B<!$N2;Id$H6hJL$9$k(B($BDL>o(B)
                    1-$B<!$N2;Id$H$D$J$2$k(B($B%9%i!<(B,$B%?%$(B,$BIUE@2;Id(B)
    $B2<0L(B8$B%S%C%H(B(bit7-0)$B!'2;3,(B
            $B4p=`2;(B=80h$B$H$7$?AjBPCM!#$?$@$7(B00h$B$O5YId!#(B
******************************************************************************/
// $B!V>.$5$J@$3&!W(B -------------------------------------------------------------
const unsigned int MelodyData1[] = {
    0x037b,0x037c,0x027e,0x0287,0x0283,
    0x0385,0x0383,0x0283,0x0282,0x0282,

    0x0379,0x037b,0x027c,0x0285,0x0282,
    0x0383,0x0382,0x0280,0x027e,0x027e,

    0x037b,0x037c,0x027e,0x0383,0x0385,0x0287,
    0x0385,0x0383,0x0280,0x0385,0x0387,0x0288,
    0x0387,0x0385,0x027e,0x0288,0x0287,0x0285,0x0183,0x0200,

    0xffff  //$B%F!<%V%k=*N;%^!<%/(B
};

//$B!V9S>k$N7n!W!!:n6J!'BlNwB@O:(B ------------------------------------------------
const unsigned int MelodyData2[] = {
    0x037d,0x037d,0x0382,0x0384,0x0385,0x0384,0x0282,
    0x037e,0x037e,0x037d,0x037c,0x027d,0x0200,

    0x037d,0x037d,0x0382,0x0384,0x0385,0x0384,0x0282,
    0x037e,0x037B,0x837d,0x047d,0x047d,0x0276,0x0200,

    0x0379,0x0379,0x0378,0x0376,0x837e,0x047e,0x047e,0x027d,
    0x037b,0x037d,0x837e,0x047e,0x047e,0x027d,0x0200,

    0x037d,0x037d,0x0382,0x0384,0x0385,0x0384,0x0282,
    0x037e,0x037B,0x837d,0x047d,0x047d,0x0276,0x0200,

    0x0200,

    0xffff  //$B%F!<%V%k=*N;%^!<%/(B
};

//$B!V[07nLk!W!!:n6J!'2,LnDg0l(B --------------------------------------------------
const unsigned int MelodyData3[] = {
    0x037d,0x037d,
    0x8279,0x0379,0x037b,0x037d,0x0380,
    0x0380,0x0382,0x0280,0x027b,
    0x827d,0x037d,0x0379,0x037b,0x0380,
    0x017d,0x0380,0x0380,

    0x827d,0x037d,0x037e,0x0380,0x0385,
    0x0385,0x0387,0x0285,0x0280,
    0x8282,0x0382,0x037d,0x037b,0x037b,
    0x0179,0x0380,0x0380,

    0x8285,0x0385,0x0385,0x0385,0x0387,
    0x0385,0x0382,0x0280,0x0380,0x037d,
    0x8280,0x0380,0x0382,0x037d,0x037d,
    0x017b,0x8379,0x037b,

    0x827d,0x037d,0x0379,0x037d,0x037e,
    0x0380,0x0385,0x0282,0x0280,
    0x8282,0x0382,0x037d,0x037b,0x037b,
    0x0179,

    0x0200,

    0xffff  //$B%F!<%V%k=*N;%^!<%/(B
};

/******************************************************************************
 $B%0%m!<%P%kJQ?t$NDj5A$H%$%K%7%c%i%$%:(B(RAM)
******************************************************************************/
// $B%a%m%G%#$K4X78$7$?JQ?t(B -----------------------------------------------------
unsigned char       Melody = 1;     //$B$I$N%a%m%G%#$,A*$P$l$F$$$k$+(B
unsigned char       MelodyFlag = 0; //$B%a%m%G%#%U%i%0(B
                                    // 0:$BDd;_(B
                                    // 1:$B2;3Z%9%?!<%H(B
                                    // 2:$B2;Id(B
                                    // 3:$B5YId(B
                                    // 4:$B2;3Z=*N;(B
unsigned int        OnpuCnt;        //$B2;Id%+%&%s%?(B
unsigned int        KyufuCnt;       //$B5YId%+%&%s%?(B
const unsigned int  *GakufuPnt;     //$B3ZIh%]%$%s%?(B($B%W%m%0%i%`%a%b%j$r$5$9%]%$%s%?JQ?t$GDj5A(B)

unsigned char       SounderStatus = 1;

// LED$BI=<($K4X78$7$?JQ?t(B ------------------------------------------------------
unsigned char   ScanCnt = 0;    //$B%9%-%c%s%+%&%s%?(B
unsigned char   DispBuf[8] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}; //$BI=<(%P%C%U%!(B

// $B%9%$%C%AF~NO$K4X78$7$?JQ?t(B -------------------------------------------------
unsigned char   SwData1  = 0;   //$B%U%!!<%9%H%j!<%I(B
unsigned char   SwData2  = 0;   //$B%@%V%k%j!<%I$K$h$j7hDj$7$?%G!<%?(B
unsigned char   SwData3  = 0;   //$BA02s$N%@%V%k%j!<%I$G7hDj$7$?%G!<%?(B
unsigned char   SwData4  = 0;   //0$B"*(B1$B$KJQ2=$7$?%G!<%?(B
unsigned char   SwStatus = 0;   //$B%9%$%C%AF~NO%9%F!<%?%9(B(0:$B%U%!!<%9%H%j!<%I(B/1:$B%@%V%k%j!<%I(B)

// $B%=%U%H%&%'%"%?%$%^$K4X78$7$?JQ?t(B -------------------------------------------
struct SoftTimer{           //$B%=%U%H%&%'%"%?%$%^$N9=B$BN%?%0(B
    unsigned char   Status; //$B%?%$%^%9%F!<%?%9(B
                            // 0:$BDd;_Cf(B($B%?%$%^L$;HMQ(B)
                            // 1:$B%9%?!<%H;XNa(B
                            // 2:$B%+%&%s%HCf(B
                            // 3:$B%+%&%s%H=*N;(B
    unsigned int    Count;  //$B%?%$%^%+%&%s%?(B
};
struct SoftTimer TimT0;     //T0$B%?%$%^(B
struct SoftTimer TimT1;     //T1$B%?%$%^(B
struct SoftTimer TimT2;     //T2$B%?%$%^(B
struct SoftTimer TimT3;     //T3$B%?%$%^(B

/******************************************************************************
 $B4X?t$NDj5A(B
******************************************************************************/
void main(void);
void interrupt intr(void);
void intr_tmr0(void);
void dec_soft_timer(struct SoftTimer *,unsigned int);
void init_soft_timer(void);
void init_work_area(void);
void intr_ccp4(void);

/******************************************************************************
 $B3d$j9~$_(B(4$BHVCO%9%?!<%H(B)
******************************************************************************/
void interrupt intr(void)
{
    if (T0IF==1){intr_tmr0();}
    if (CCP4IF==1){intr_ccp4();}
}

/******************************************************************************
 TMR0 $B3d$j9~$_(B(2.048ms)
******************************************************************************/
void intr_tmr0(void)
{
    unsigned char d,s,i;
    int line, top;

    T0IF = 0;	// TMR0 Interrupt Clear

    // LED Display Scan -------------------------------------------------------
    s = ScanData[ScanCnt];
    d = DispBuf[ScanCnt];
    for(i=0; i<8; i++){
        if((s & 0x80)==0x80)    {RA2 = 1;}
        else                    {RA2 = 0;}
        if((d & 0x80)==0x80)    {RA1 = 0;}
        else                    {RA1 = 1;}
        RA0 = 1; RA0 = 0;
        s = s << 1;
        d = d << 1;
    }
    ScanCnt++; if(ScanCnt>=8){ScanCnt = 0;}

    // Switch Input -----------------------------------------------------------
    switch(SwStatus){
        case 0:
            SwData1 = ~PORTA & 0xf0;
            if (SwData1!=0) {SwStatus = 1;}
            else            {SwData2 = SwData3 =0;}
            break;
        case 1:
            if (SwData1==(~PORTA & 0xf0)){
                SwData2 = SwData1;
                SwData4 = SwData4 | (SwData2 & (~SwData3));
                SwData3 = SwData2;
            }
            SwStatus = 0;
            break;
    }

    //$B%=%U%H%&%'%"%?%$%^(B ------------------------------------------------------
    if (TimT0.Status==1 || TimT0.Status==2){dec_soft_timer(&TimT0,T0/2);}   //T0
    if (TimT1.Status==1 || TimT1.Status==2){dec_soft_timer(&TimT1,T1/2);}   //T1
    if (TimT2.Status==1 || TimT2.Status==2){dec_soft_timer(&TimT2,T2/2);}   //T2
    if (TimT3.Status==1 || TimT3.Status==2){dec_soft_timer(&TimT3,T3/2);}   //T3
}

/******************************************************************************
 $B%=%U%H%&%'%"%?%$%^$N%G%/%j%a%s%H(B
-------------------------------------------------------------------------------
    $B0z?t(B    *pst    $B%=%U%H%&%'%"%?%$%^9=B$BN$N%]%$%s%?(B
            initial $B%?%$%^%+%&%s%?$N=i4|CM(B
******************************************************************************/
void dec_soft_timer(struct SoftTimer *pst,unsigned int initial)
{
    if (pst->Status==1){            //$B%?%$%^%9%?!<%H;XNa(B
        pst->Status =   2;          //$B%+%&%s%HCf%;%C%H(B
        pst->Count  =   initial;    //$B%?%$%^%+%&%s%?=i4|2=(B
    }
    pst->Count--;   //$B%+%&%s%?(B-1
    if (pst->Count==0){             //$B%+%&%s%?$,(B0$B$K$J$C$?(B
        pst->Status =   3;          //$B%+%&%s%H=*N;%;%C%H(B
    }
}

/******************************************************************************
 $B%=%U%H%&%'%"%?%$%^$N%$%K%7%c%i%$%:(B
******************************************************************************/
void init_soft_timer(void)
{
    TimT0.Status = 0; TimT1.Status = 0; TimT2.Status = 0; TimT3.Status = 0;
}

/******************************************************************************
 CCP4 $B3d$j9~$_(B
******************************************************************************/
void intr_ccp4(void)
{
    unsigned char	Onkai;
    unsigned char	Onpu;
    unsigned char	Kyufu;

    unsigned char p,a,b;

    //CCP4$B3d$j9~$_%U%i%0%/%j%"(B
    CCP4IF =0;

    //$B%a%m%G%#(B
    switch (MelodyFlag){
        //$BDd;_(B ----------------------------------------------------------------
        case 0:
            CCPR4L = 40816 % 0x0100;  //10ms$B$G3d9~$_$r$+$1$k(B
            CCPR4H = 40816 / 0x0100;
            SounderStatus = 1;
            break;
        //$B2;Id>pJs<hF@(B --------------------------------------------------------
        case 1:
            if (*GakufuPnt==0xffff){    //$B3ZIh=*N;(B
                SounderStatus = 1;
                MelodyFlag = 4;
                break;
            }

            Onkai = (unsigned char)(*GakufuPnt & 0x00ff);   //$B2;3,(B
            Onpu  = (unsigned char)(*GakufuPnt / 0x0100);   //$B2;Id$ND9$5(B
            if (Onkai!=0)   {Kyufu = 0;}                    //$B5YId$G$O$J$$(B
            else            {Onkai = 0x80; Kyufu = 1;}      //$B5YId(B
            p = Onkai - (0x80 - KIJUN_ON);  //$B2;3,%F!<%V%k$N%]%$%s%?$rF@$k(B

            //$B2;3,$K$"$o$;$F(BCCP4$B$N%3%s%Z%"CM$r%;%C%H$9$k(B,$B3d9~$_4V3V$ND4@0(B
            TMR1ON = 0;     //$B%?%$%^(B1$BDd;_(B
            CCPR4L = OnkaiTbl[p][0] % 0x0100; //$B%3%s%Z%"CM(B($B2<0L(B8bit)
            CCPR4H = OnkaiTbl[p][0] / 0x0100; //$B%3%s%Z%"CM(B($B>e0L(B8bit)
            TMR1L = 0x00;   //$B%+%&%s%?%/%j%"(B($B2<0L(B8bit)
            TMR1H = 0x00;   //$B%+%&%s%?%/%j%"(B($B>e0L(B8bit)
            TMR1ON = 1;     //$B%?%$%^(B1$B%9%?!<%H(B

            OnpuCnt = OnkaiTbl[p][1];   //$BA42;Id$ND9$5(B
            if ((Onpu & 0x7f)!=0){
                OnpuCnt = OnpuCnt >> (Onpu & 0x7f); //$B2;Id$ND9$5$r7hDj(B
            }
            if (Kyufu==0){  //$B2;Id(B
                if ((Onpu&0x80)==0){    //$B<!$N2;$H4V3V$r3+$1$k(B
                    KyufuCnt = OnpuCnt / 16;
                    OnpuCnt = OnpuCnt - KyufuCnt;
                }
                else{                   //$B<!$N2;$H$D$J$2$k(B
                    KyufuCnt = 0;
                }
                MelodyFlag = 2;
            }
            else{           //$B5YId(B
                KyufuCnt = OnpuCnt;
                OnpuCnt = 0;
                MelodyFlag = 3;
            }

            GakufuPnt++;    //$B<!$N2;Id$N%]%$%s%?$K(B
            break;
        //$B2;Id(B ----------------------------------------------------------------
        case 2:
            if(SounderStatus==1)    {SounderStatus = 0;}
            else                    {SounderStatus = 1;}
            OnpuCnt--;
            if (OnpuCnt==0){
                if (KyufuCnt==0)    {MelodyFlag = 1;}   //$B<!$N2;$K$D$J$2$k(B
                else                {MelodyFlag = 3;}   //$B4V3V$r6u$1$k(B
            }
            break;
        //$B5YId(B ----------------------------------------------------------------
        case 3:
            SounderStatus = 1;
            KyufuCnt--;
            if (KyufuCnt==0) {MelodyFlag = 1;}  //$B=*N;$7$?$i<!$N2;Id$K0\$k(B
            break;
    }

    //$B%5%&%s%@=PNO(B
    if(SounderStatus==1)    {LATA3 = 1;}
    else                    {LATA3 = 0;}
}
/******************************************************************************
 $B%a%$%s%W%m%0%i%`(B
******************************************************************************/
void main(void)
{
    // Option Registor Initialze
    OPTION_REG = 0x85;  // Prescaler = 64

    // Oscillator Initialize
    OSCCON = 0xf0;  // 4xPLL-Enable,8MHz = 32MHz

    // I/O Port Initialize
    ANSELA = 0x00;
    TRISA = 0xf0;
    PORTA = 0x0a;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    ANSELB = 0x00;
    TRISB = 0x00;

    // TMR0 Initialize
    init_soft_timer();  //$B%=%U%H%&%'%"%?%$%^%$%K%7%c%i%$%:(B
    TMR0 = 0x00;        // 32MHz/4/64/256 -> 2.048ms

    // TMR1 Initialize
    T1CON = 0x00;   //$B%W%j%9%1!<%i(B=1,$BFbIt%/%m%C%/(B(32MHz/4=8MHz),$B%?%$%^(B1$B%9%H%C%W(B
    TMR1L = 0x00;   //$B%+%&%s%?%/%j%"(B($B2<0L(B8bit)
    TMR1H = 0x00;   //$B%+%&%s%?%/%j%"(B($B>e0L(B8bit)
    TMR1ON = 1;     //$B%?%$%^(B1$B%9%?!<%H(B

    // CCP Initialize
    CCP4CON = 0x0b; //$B%3%s%Z%"%b!<%I(B,$B%9%Z%7%c%k%$%Y%s%H%H%j%,(B
    CCPR4L = 40816 % 0x0100; //10ms
    CCPR4H = 40816 / 0x0100;

    // Interrupt Initialize
    T0IE = 1;		// TMR0 Interrupt Enable
    PIR1 = 0x00;        // Peripheral Interrupt Request Register Clear
    PIR2 = 0x00;        // Peripheral Interrupt Request Register Clear
    PIR3 = 0x00;        // Peripheral Interrupt Request Register Clear
    PIR4 = 0x00;        // Peripheral Interrupt Request Register Clear
    PIE1 = 0x00;        // Peripheral Interrupt Enable Register Clear (=Disable)
    PIE2 = 0x00;        // Peripheral Interrupt Enable Register Clear (=Disable)
    PIE3 = 0x00;        // Peripheral Interrupt Enable Register Clear (=Disable)
    PIE4 = 0x00;        // Peripheral Interrupt Enable Register Clear (=Disable)
    CCP4IF = 0;         // CCP4 Interrupt Flag Clear
    CCP4IE = 1;         // CCP4 Interrupt Enable
    PEIE = 1;           // All Periferal Interrupt Enable
    GIE = 1;		// Interrupt Enable

    // Work Area Initialize
    init_work_area();

    // Main Loop --------------------------------------------------------------
    while(1){
        //$B%a%m%G%#$NA*Br(B
        if ((SwData4 & 0x10)==0x10){
            if (Melody!=1){
                MelodyFlag = 0; //$B:#$N%a%m%G%#$r%9%H%C%W(B
                Melody = 1;     //$BA*Br$5$l$?%a%m%G%#(B
            }
            SwData4 = 0;
        }
        else if ((SwData4 & 0x20)==0x20){
            if (Melody!=2){
                MelodyFlag = 0; //$B:#$N%a%m%G%#$r%9%H%C%W(B
                Melody = 2;     //$BA*Br$5$l$?%a%m%G%#(B
            }
            SwData4 = 0;
        }
        else if ((SwData4 & 0x40)==0x40){
            if (Melody!=3){
                MelodyFlag = 0; //$B:#$N%a%m%G%#$r%9%H%C%W(B
                Melody = 3;     //$BA*Br$5$l$?%a%m%G%#(B
            }
            SwData4 = 0;
        }
        else if ((SwData4 & 0x80)==0x80){
            MelodyFlag = 0; //$B:#$N%a%m%G%#$r%9%H%C%W(B
            Melody++ ;if(Melody>3) {Melody = 1;}    //$B<!$N%a%m%G%#(B
            SwData4 = 0;
        }

        //$B%a%m%G%#%9%?!<%H(B
        if ((MelodyFlag==0)||(MelodyFlag==4)){
            switch(Melody){
                case 1:
                    GakufuPnt = MelodyData1;    //$B%a%m%G%#%F!<%V%k$N@hF,%"%I%l%9$r%;%C%H(B
                    MelodyFlag = 1;             //$B%a%m%G%#%9%?!<%H(B
                    break;
                case 2:
                    GakufuPnt = MelodyData2;    //$B%a%m%G%#%F!<%V%k$N@hF,%"%I%l%9$r%;%C%H(B
                    MelodyFlag = 1;             //$B%a%m%G%#%9%?!<%H(B
                    break;
                case 3:
                    GakufuPnt = MelodyData3;    //$B%a%m%G%#%F!<%V%k$N@hF,%"%I%l%9$r%;%C%H(B
                    MelodyFlag = 1;             //$B%a%m%G%#%9%?!<%H(B
                    break;
            }
        }
    }
}

/******************************************************************************
 $B%o!<%/%(%j%"$N=i4|@_Dj(B
******************************************************************************/
void init_work_area(void)
{

}
