/*
 * File:   timer_pic16f1827.c
 * Author: kikusan
 *
 * Created on 2012/12/13, 14:09
 */

/*
 * 1$BJ,(B-99$BJ,%-%C%A%s%?%$%^!<%W%m%0%i%`(B
 * SW1 $B%?%$%^%9%?!<%H(B/$B%9%H%C%W(B
 * SW2 $BL$;HMQ(B
 * SW3 $B%?%$%^CM(B +1$B!J%?%$%^%9%H%C%WCf$N$_!K(B
 * SW4 $B%?%$%^CM(B -1$B!J%?%$%^%9%H%C%WCf$N$_!K(B
 * $B%?%$%^F0:nCf$OI=<($,E@LG$7!$(B00$B$K$J$k$H%V%6!<$,LD$j$^$9!#(B
 * $B2?$+%9%$%C%A$r2!$9$H%V%6!<$,;_$^$j$^$9!#(B
 * $B@_Dj$7$?%?%$%^CM$O(BEEPROM$B$K5-O?$5$lEE8;$r%*%U$K$7$F$b>C$($^$;$s!#(B
 */

// PIC16F1827 Configuration Bit Settings
#pragma config FOSC = INTOSC, WDTE = OFF, PWRTE = ON,MCLRE = OFF, CP = OFF
#pragma config CPD = OFF, BOREN = ON, CLKOUTEN = OFF, IESO = ON,FCMEN = ON
#pragma config WRT = OFF,PLLEN = ON, STVREN = ON, BORV = LO, LVP = OFF

/******************************************************************************
 $B%$%s%/%k!<%I%U%!%$%k(B
******************************************************************************/
#include <xc.h>

/******************************************************************************
 $BDj?t$NDj5A!JD>@\;XDj!K(B
******************************************************************************/
#define OK      0   //$BLa$jCM(B
#define NG      -1  //$BLa$jCM(B
#define TRUE    0   //$BLa$jCM(B
#define FALSE   -1  //$BLa$jCM(B

//$B%=%U%H%&%'%"%?%$%^(B ----------------------------------------------------------
#define T0      500     //T0(500ms)     $B8:;;%?%$%_%s%0(B
#define T1      100     //T1(100ms)     $B%0%i%U%#%C%/I=<(%?%$%^(B
#define T2      0       //T2(0ms)
#define T3      0       //T3(0ms)

/******************************************************************************
 EEPROM$B$N=i4|CM(B
******************************************************************************/
eeprom signed char eep_min[2] = {9,9};  //$B$3$N=q$-J}$O8E$$!#0JA0$N%3%s%Q%$%i$H$N8_49$N$?$a$K;D$5$l$F$$$k$i$7$$!#(B
//__EEPROM_DATA(9,9,0,0,0,0,0,0);   //$B?d>)$5$l$F$$$k$N$O$3$A$i$N=q$-J}$@$,(B"!"$B$,I=<($5$l$k!#%S%k%I$O(BOK$B!#(B

/******************************************************************************
 $BDj?t%(%j%"$NDj5A(B(ROM)
******************************************************************************/
//$B%9%-%c%s%G!<%?(B
const unsigned char ScanData[8] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

//$B%-%c%i%/%?%G!<%?(B(4$B!_(B8)
const unsigned char LEDDispData[][4] = {
    {0x00,0xff,0x81,0xff},  // 0
    {0x00,0x02,0xff,0x00},  // 1
    {0x00,0xf1,0x91,0x9f},  // 2
    {0x00,0x89,0x89,0xff},  // 3
    {0x00,0x1f,0x10,0xff},  // 4
    {0x00,0x8f,0x89,0xf9},  // 5
    {0x00,0xff,0x89,0xf9},  // 6
    {0x00,0x0f,0x01,0xff},  // 7
    {0x00,0xff,0x89,0xff},  // 8
    {0x00,0x9f,0x91,0xff},  // 9
};

//$B%?%$%^=*N;;~$N%0%i%U%#%C%/%G!<%?(B
const unsigned char GraphData[16][8] = {
    {0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x81},  // 0
    {0x83,0x80,0x00,0x00,0x00,0x00,0x01,0xc1},  // 1
    {0x83,0x84,0x40,0x00,0x00,0x02,0x21,0xc1},  // 2
    {0x83,0x84,0x48,0x20,0x04,0x12,0x21,0xc1},  // 3
    {0x83,0x84,0x48,0x38,0x1c,0x12,0x21,0xc1},  // 4
    {0x02,0x84,0x48,0x38,0x1c,0x12,0x21,0x40},  // 5
    {0x00,0x04,0x48,0x38,0x1c,0x12,0x20,0x00},  // 6
    {0x00,0x00,0x08,0x38,0x1c,0x10,0x00,0x00},  // 7
    {0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00},  // 8
    {0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00},  // 9
    {0x00,0x00,0x18,0x24,0x24,0x18,0x00,0x00},  //10
    {0x00,0x3c,0x42,0x42,0x42,0x42,0x3c,0x00},  //11
    {0x3c,0x42,0x81,0x81,0x81,0x81,0x42,0x3c},  //12
    {0x42,0x81,0x00,0x00,0x00,0x00,0x81,0x42},  //13
    {0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x81},  //14
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  //15
};

/******************************************************************************
 $B%0%m!<%P%kJQ?t$NDj5A$H%$%K%7%c%i%$%:(B(RAM)
******************************************************************************/
// $B%-%C%A%s%?%$%^$K4X78$7$?JQ?t(B -----------------------------------------------
unsigned char   TimerStatus;    //$B%-%C%A%s%?%$%^%9%F!<%?%9(B
                                // 0:$B@_DjCf(B
                                // 1:$B8:;;%+%&%s%HCf(B
                                // 2:$B=*N;(B
unsigned char   sec05;          //0.5$BIC(B
signed char     sec00;          //  0$BIC(B
signed char     sec10;          // 10$BIC(B
signed char     min00;          //  0$BJ,(B
signed char     min10;          // 10$BJ,(B
signed char     save_min00;     //  0$BJ,(B:$BJ]B8MQ(B
signed char     save_min10;     // 10$BJ,(B:$BJ]B8MQ(B
unsigned char   GraphCnt;       //$B%0%i%U%#%C%/I=<(%+%&%s%?(B
unsigned int    BzCnt;          //$B=*N;;~$N%V%6!<MQ(B

// LED$BI=<($K4X78$7$?JQ?t(B ------------------------------------------------------
unsigned char   ScanCnt = 0;    //$B%9%-%c%s%+%&%s%?(B
unsigned char   DispBuf[8] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}; //$BI=<(%P%C%U%!(B

// $B%9%$%C%AF~NO$K4X78$7$?JQ?t(B -------------------------------------------------
unsigned char   SwData1  = 0;   //$B%U%!!<%9%H%j!<%I(B
unsigned char   SwData2  = 0;   //$B%@%V%k%j!<%I$K$h$j7hDj$7$?%G!<%?(B
unsigned char   SwData3  = 0;   //$BA02s$N%@%V%k%j!<%I$G7hDj$7$?%G!<%?(B
unsigned char   SwData4  = 0;   //0$B"*(B1$B$KJQ2=$7$?%G!<%?(B
unsigned char   SwStatus = 0;   //$B%9%$%C%AF~NO%9%F!<%?%9(B(0:$B%U%!!<%9%H%j!<%I(B/1:$B%@%V%k%j!<%I(B)

// $B%=%U%H%&%'%"%?%$%^$K4X78$7$?JQ?t(B -------------------------------------------
struct SoftTimer{           //$B%=%U%H%&%'%"%?%$%^$N9=B$BN%?%0(B
    unsigned char   Status; //$B%?%$%^%9%F!<%?%9(B
                            // 0:$BDd;_Cf(B($B%?%$%^L$;HMQ(B)
                            // 1:$B%9%?!<%H;XNa(B
                            // 2:$B%+%&%s%HCf(B
                            // 3:$B%+%&%s%H=*N;(B
    unsigned int    Count;  //$B%?%$%^%+%&%s%?(B
};
struct SoftTimer TimT0;     //T0$B%?%$%^(B
struct SoftTimer TimT1;     //T1$B%?%$%^(B
struct SoftTimer TimT2;     //T2$B%?%$%^(B
struct SoftTimer TimT3;     //T3$B%?%$%^(B

/******************************************************************************
 $B4X?t$NDj5A(B
******************************************************************************/
void main(void);
void interrupt intr(void);
void intr_tmr0(void);
void dec_soft_timer(struct SoftTimer *,unsigned int);
void init_soft_timer(void);
void click_bz(void);
void init_work_area(void);
signed char eep_rd_one(unsigned char);
void eep_wr_one(unsigned char,signed char);

/******************************************************************************
 $B3d$j9~$_(B(4$BHVCO%9%?!<%H(B)
******************************************************************************/
void interrupt intr(void)
{
    if (T0IF==1){intr_tmr0();}
}

/******************************************************************************
 TMR0 $B3d$j9~$_(B(2.048ms)
******************************************************************************/
void intr_tmr0(void)
{
    unsigned char d,s,i;
    int line, top;

    T0IF = 0;	// TMR0 Interrupt Clear

    // LED Display Scan -------------------------------------------------------
    s = ScanData[ScanCnt];
    d = DispBuf[ScanCnt];
    for(i=0; i<8; i++){
        if((s & 0x80)==0x80)    {RA2 = 1;}
        else                    {RA2 = 0;}
        if((d & 0x80)==0x80)    {RA1 = 0;}
        else                    {RA1 = 1;}
        RA0 = 1; RA0 = 0;
        s = s << 1;
        d = d << 1;
    }
    ScanCnt++; if(ScanCnt>=8){ScanCnt = 0;}

    // Switch Input -----------------------------------------------------------
    switch(SwStatus){
        case 0:
            SwData1 = ~PORTA & 0xf0;
            if (SwData1!=0) {SwStatus = 1;}
            else            {SwData2 = SwData3 =0;}
            break;
        case 1:
            if (SwData1==(~PORTA & 0xf0)){
                SwData2 = SwData1;
                SwData4 = SwData4 | (SwData2 & (~SwData3));
                SwData3 = SwData2;
            }
            SwStatus = 0;
            break;
    }

    //$B%=%U%H%&%'%"%?%$%^(B ------------------------------------------------------
    if (TimT0.Status==1 || TimT0.Status==2){dec_soft_timer(&TimT0,T0/2);}   //T0
    if (TimT1.Status==1 || TimT1.Status==2){dec_soft_timer(&TimT1,T1/2);}   //T1
    if (TimT2.Status==1 || TimT2.Status==2){dec_soft_timer(&TimT2,T2/2);}   //T2
    if (TimT3.Status==1 || TimT3.Status==2){dec_soft_timer(&TimT3,T3/2);}   //T3
}

/******************************************************************************
 $B%=%U%H%&%'%"%?%$%^$N%G%/%j%a%s%H(B
-------------------------------------------------------------------------------
    $B0z?t(B    *pst    $B%=%U%H%&%'%"%?%$%^9=B$BN$N%]%$%s%?(B
            initial $B%?%$%^%+%&%s%?$N=i4|CM(B
******************************************************************************/
void dec_soft_timer(struct SoftTimer *pst,unsigned int initial)
{
    if (pst->Status==1){            //$B%?%$%^%9%?!<%H;XNa(B
        pst->Status =   2;          //$B%+%&%s%HCf%;%C%H(B
        pst->Count  =   initial;    //$B%?%$%^%+%&%s%?=i4|2=(B
    }
    pst->Count--;   //$B%+%&%s%?(B-1
    if (pst->Count==0){             //$B%+%&%s%?$,(B0$B$K$J$C$?(B
        pst->Status =   3;          //$B%+%&%s%H=*N;%;%C%H(B
    }
}

/******************************************************************************
 $B%=%U%H%&%'%"%?%$%^$N%$%K%7%c%i%$%:(B
******************************************************************************/
void init_soft_timer(void)
{
    TimT0.Status = 0; TimT1.Status = 0; TimT2.Status = 0; TimT3.Status = 0;
}

/******************************************************************************
 $B%a%$%s%W%m%0%i%`(B
******************************************************************************/
void main(void)
{
    // Option Registor Initialze
    OPTION_REG = 0x85;  // Prescaler = 64

    // Oscillator Initialize
    OSCCON = 0xf0;  // 4xPLL-Enable,8MHz = 32MHz

    // I/O Port Initialize
    ANSELA = 0x00;
    TRISA = 0xf0;
    PORTA = 0x0a;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    RA0 = 1; RA0 = 0;
    ANSELB = 0x00;
    TRISB = 0xff;

    // TMR0 Initialize
    init_soft_timer();  //$B%=%U%H%&%'%"%?%$%^%$%K%7%c%i%$%:(B
    TMR0 = 0x00;        // 32MHz/4/64/256 -> 2.048ms

    // Interrupt Initialize
    T0IE = 1;		// TMR0 Interrupt Enable
    GIE = 1;		// Interrupt Enable

    // Work Area Initialize
    init_work_area();

        // Main Loop --------------------------------------------------------------
    while(1){
        switch(TimerStatus){
            //$B@_DjCf(B ----------------------------------------------------------
            case 0:
                if      ((SwData4 & 0x10)==0x10){   //SW1$B$,2!$5$l$?(B
                    click_bz();
                    save_min00 = min00; save_min10 = min10;
                    eep_wr_one(0x00,min00);
                    eep_wr_one(0x01,min10);
                    TimerStatus = 1;
                    TimT0.Status = 1;
                    SwData4 = 0;
                }
                else if ((SwData4 & 0x40)==0x40){   //SW3$B$,2!$5$l$?(B
                    click_bz();
                    min00++;
                    if (min00>9){
                        min00 = 0;
                        min10++;
                        if (min10>9){
                            min10 = 0;
                        }
                    }
                    sec05 = 1; sec00 = 0; sec10 = 6;
                    SwData4 = 0;
                }
                else if ((SwData4 & 0x80)==0x80){   //SW4$B$,2!$5$l$?(B
                    click_bz();
                    min00--;
                    if (min00<0){
                        min00 = 9;
                        min10--;
                        if (min10<0){
                            min10 = 9;
                        }
                    }
                    sec05 = 1; sec00 = 0; sec10 = 6;
                    SwData4 = 0;
                }
                break;
            //$B8:;;%+%&%s%HCf(B --------------------------------------------------
            case 1:
                if (TimT0.Status==3){
                    TimT0.Status = 1;
                    sec05 = sec05 ^ 0x01;
                    if (sec05==0x01){
                        sec00--; if (sec00<0){sec00 = 9; sec10--;}
                        if ((sec00|sec10)==0){
                            sec10 = 6; sec00 = 0;
                            min00--;
                            if (min00<0){
                                min00 = 9;
                                min10--;
                                if (min10<0){
                                    min10 = 9;
                                }
                            }
                        }
                        if ((min00|min10)==0){
                            TimT0.Status = 0;
                            TimerStatus = 3;
                        }
                    }
                }
                if      ((SwData4 & 0x10)==0x10){   //SW1$B$,2!$5$l$?(B
                    click_bz();
                    TimerStatus = 2;
                    TimT0.Status = 0;
                    sec05 = 1;
                    SwData4 = 0;
                }
                break;
            //$B0l;~Dd;_(B --------------------------------------------------------
            case 2:
                if      ((SwData4 & 0x10)==0x10){   //SW1$B$,2!$5$l$?(B
                    click_bz();
                    TimerStatus = 1;
                    TimT0.Status = 1;
                    SwData4 = 0;
                }
                else if ((SwData4 & 0xc0)!=0x00){   //SW3,4$B$,2!$5$l$?(B
                    TimerStatus = 0;
                    SwData4 = 0;
                }
                break;
            //$B=*N;(B ------------------------------------------------------------
            case 3:
                //$B%0%i%U%#%C%/I=<(%?%$%^%9%?!<%H(B
                if (TimT1.Status==0){
                    TimT1.Status=1;
                    GraphCnt = 0;
                }
                //$B%0%i%U%#%C%/I=<(%Q%?!<%s$N@_Dj(B
                if (TimT1.Status==3){
                    TimT1.Status = 1;
                    GraphCnt++; if(GraphCnt>=16) {GraphCnt = 0;}
                }
                //$B%V%6!<$rLD$i$9(B
                BzCnt++;
                if ((BzCnt & 0x8208)==0)    {RA3 = 0;}
                else                        {RA3 = 1;}
                //$B2?$+%9%$%C%A$,2!$5$l$?$i:G=i$KLa$k(B
                if ((SwData4 & 0xf0)!=0x00){
                    sec05 = 1; sec00 = 0; sec10 = 6;
                    min00 = save_min00; min10 = save_min10;
                    TimerStatus = 0;
                    TimT1.Status = 0;
                    RA3 = 1;
                    BzCnt = 0;
                    SwData4 = 0;
                }
                break;
        }

        // LED$B%G!<%?%;%C%H(B ----------------------------------------------------
        switch(TimerStatus){
            case 0:
            case 1:
            case 2:
                if ((min10==0)&(min00==1)&((sec10*10+sec00)<10)){
                    DispBuf[0] = LEDDispData[sec10][0];
                    DispBuf[1] = LEDDispData[sec10][1];
                    DispBuf[2] = LEDDispData[sec10][2];
                    DispBuf[3] = LEDDispData[sec10][3];
                    DispBuf[4] = LEDDispData[sec00][0];
                    DispBuf[5] = LEDDispData[sec00][1];
                    DispBuf[6] = LEDDispData[sec00][2];
                    DispBuf[7] = LEDDispData[sec00][3];
                }
                else{
                    if (sec05==1){
                        DispBuf[0] = LEDDispData[min10][0];
                        DispBuf[1] = LEDDispData[min10][1];
                        DispBuf[2] = LEDDispData[min10][2];
                        DispBuf[3] = LEDDispData[min10][3];
                        DispBuf[4] = LEDDispData[min00][0];
                        DispBuf[5] = LEDDispData[min00][1];
                        DispBuf[6] = LEDDispData[min00][2];
                        DispBuf[7] = LEDDispData[min00][3];
                    }
                    else{
                        DispBuf[0] = DispBuf[1] = DispBuf[2] = DispBuf[3] =
                        DispBuf[4] = DispBuf[5] = DispBuf[6] = DispBuf[7] = 0;
                    }
                }
                break;
            case 3:
                DispBuf[0] = GraphData[GraphCnt][0];
                DispBuf[1] = GraphData[GraphCnt][1];
                DispBuf[2] = GraphData[GraphCnt][2];
                DispBuf[3] = GraphData[GraphCnt][3];
                DispBuf[4] = GraphData[GraphCnt][4];
                DispBuf[5] = GraphData[GraphCnt][5];
                DispBuf[6] = GraphData[GraphCnt][6];
                DispBuf[7] = GraphData[GraphCnt][7];
                break;
        }
    }
}

/******************************************************************************
 $B%/%j%C%/2;(B
******************************************************************************/
void click_bz(void)
{
    unsigned int i;

    RA3 = 1;

    for (i=0; i<0x4000; i++){
        if ((i & 0x0010)==0)    {RA3 = 0;}
        else                    {RA3 = 1;}
    }

    RA3 = 1;
}

/******************************************************************************
 $B%o!<%/%(%j%"$N=i4|@_Dj(B
******************************************************************************/
void init_work_area(void)
{
    TimerStatus = 0;
    save_min00 = eep_rd_one(0x00);
    save_min10 = eep_rd_one(0x01);
    if ((save_min00<0)||(save_min00>9)||(save_min10<0)||(save_min10>9)){
        save_min00 = 9;
        save_min10 = 9;
    }
    BzCnt = 0;
    sec05 = 1;
    sec00 = 0; sec10 = 6;
    min00 = save_min00; min10 = save_min10;
}

/******************************************************************************
 EEPROM$B%G!<%?%a%b%j$N(B1$B%P%$%H%j!<%I(B
******************************************************************************/
signed char eep_rd_one(unsigned char addr)  //addr=EEPROM$B$N%"%I%l%9(B
{
    signed char data;   //data=$BFI$_=P$5$l$?%G!<%?(B

    EEADR = addr;   //$B%"%I%l%9%;%C%H(B
    EEPGD = 0;      //$B%G!<%?(BEEPROM$BA*Br(B
    RD = 1;         //EEPROM$B%j!<%I%9%?!<%H(B
    data = EEDATA;  //$B%G!<%?%j!<%I(B
    return data;
}

/******************************************************************************
 EEPROM$B%G!<%?%a%b%j$N(B1$B%P%$%H%i%$%H(B
******************************************************************************/
void eep_wr_one(unsigned char addr,signed char data)    //addr=EEPROM$B$N%"%I%l%9(B,data=$B=q$-9~$`%G!<%?(B
{
    GIE = 0;        //$B3d$j9~$_6X;_(B
    EEADR = addr;   //$B%"%I%l%9%;%C%H(B
    EEDATA = data;  //$B%G!<%?%;%C%H(B
    EEPGD = 0;      //$B%G!<%?(BEEPROM$BA*Br(B
    WREN = 1;       //EEPROM$B%i%$%H%$%M!<%V%k(B
    EECON2 = 0x55;  //$B=q$-9~$_%7!<%1%s%9(B : EECON2$B$K(B0x55,0xAA$B$r=q$$$F$+$i(BWR$B$r(B1$B$K$9$k$H(B
    EECON2 = 0xaa;  //$B=q$-9~$_%7!<%1%s%9(B : $B=q$-9~$_$r%9%?!<%H$G$-$k(B
    WR = 1;         //$B%i%$%H%5%$%/%k%9%?!<%H(B
    while(WR==1){}  //$B%i%$%H%5%$%/%k=*N;$^$GBT$D(B
    WREN = 0;       //EEPROM$B%i%$%H%G%#%;!<%V%k(B
    GIE = 1;        //$B3d$j9~$_5v2D(B
}
